/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2023 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.ASTQ = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(_dereq_,module,exports){
(function (global){(function (){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this).ASTY=e()}}(function(){return function(){return function e(t,n,r){function i(u,a){if(!n[u]){if(!t[u]){var f="function"==typeof _dereq_&&_dereq_;if(!a&&f)return f(u,!0);if(o)return o(u,!0);var l=new Error("Cannot find module '"+u+"'");throw l.code="MODULE_NOT_FOUND",l}var c=n[u]={exports:{}};t[u][0].call(c.exports,function(e){return i(t[u][1][e]||e)},c,c.exports,e,t,n,r)}return n[u].exports}for(var o="function"==typeof _dereq_&&_dereq_,u=0;u<r.length;u++)i(r[u]);return i}}()({1:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,o(r.key),r)}}function o(e){var t=function(e,t){if("object"!==r(e)||null===e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var i=n.call(e,t||"default");if("object"!==r(i))return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"===r(t)?t:String(t)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var u=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&i(e.prototype,t),n&&i(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"init",value:function(e,t,n,i){if(arguments.length<2)throw new Error("init: invalid number of arguments");if(this.ctx=e,this.ASTy=!0,this.T=t,this.L={L:0,C:0,O:0},this.A={},this.C=[],this.P=null,"object"===r(n))for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&this.set(o,n[o]);return"object"===r(i)&&i instanceof Array&&this.add(i),this}},{key:"create",value:function(e,t,n){return this.ctx.create(e,t,n)}},{key:"type",value:function(e){if(0===arguments.length)return this.T;if(1===arguments.length)return this.T=e,this;throw new Error("type: invalid number of arguments")}},{key:"pos",value:function(e,t,n){if(0===arguments.length)return{line:this.L.L,column:this.L.C,offset:this.L.O};if(arguments.length<=3)return this.L.L=e||0,this.L.C=t||0,this.L.O=n||0,this;throw new Error("pos: invalid number of arguments")}},{key:"set",value:function(){for(var e=this,t=arguments.length,n=new Array(t),i=0;i<t;i++)n[i]=arguments[i];if(1===n.length&&"object"===r(n[0]))Object.keys(n[0]).forEach(function(t){void 0!==n[0][t]?e.A[t]=n[0][t]:delete e.A[t]});else{if(2!==n.length)throw new Error("set: invalid number of arguments");void 0!==n[1]?this.A[n[0]]=n[1]:delete this.A[n[0]]}return this}},{key:"unset",value:function(){for(var e=this,t=arguments.length,n=new Array(t),i=0;i<t;i++)n[i]=arguments[i];if(1===n.length&&"object"===r(n[0])&&n[0]instanceof Array)n[0].forEach(function(t){delete e.A[t]});else{if(1!==n.length)throw new Error("unset: invalid number of arguments");delete this.A[n[0]]}return this}},{key:"get",value:function(){for(var e=this,t=arguments.length,n=new Array(t),i=0;i<t;i++)n[i]=arguments[i];if(1!==n.length)throw new Error("get: invalid number of arguments");if("object"===r(n[0])&&n[0]instanceof Array)return n[0].map(function(t){if("string"!=typeof t)throw new Error("get: invalid key argument");return e.A[t]});var o=n[0];if("string"!=typeof o)throw new Error("get: invalid key argument");return this.A[o]}},{key:"attrs",value:function(){return Object.keys(this.A)}},{key:"nth",value:function(){if(null===this.P)return 1;var e=this.P.C.indexOf(this);if(e<0)throw new Error("nth: internal error -- node not in childs of its parent");return e}},{key:"ins",value:function(e){for(var t=this,n=arguments.length,i=new Array(n>1?n-1:0),o=1;o<n;o++)i[o-1]=arguments[o];if(0===i.length)throw new Error("ins: invalid number of arguments");if(e<0&&(e=this.C.length+1-e),!(e>=0&&e<=this.C.length))throw new Error("ins: invalid position");var u=function(n){if(!t.ctx.isA(n))throw new Error("ins: invalid AST node argument");t.C.splice(e++,0,n),n.P=t};return i.forEach(function(e){"object"===r(e)&&e instanceof Array?e.forEach(function(e){u(e)}):null!==e&&u(e)}),this}},{key:"add",value:function(){for(var e=this,t=arguments.length,n=new Array(t),i=0;i<t;i++)n[i]=arguments[i];if(0===n.length)throw new Error("add: invalid number of arguments");var o=function(t){if(!e.ctx.isA(t))throw new Error("add: invalid AST node argument");e.C.push(t),t.P=e};return n.forEach(function(e){"object"===r(e)&&e instanceof Array?e.forEach(function(e){o(e)}):null!==e&&o(e)}),this}},{key:"del",value:function(){for(var e=this,t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];if(0===n.length)throw new Error("del: invalid number of arguments");return n.forEach(function(t){if(!e.ctx.isA(t))throw new Error("del: invalid AST node argument");for(var n=!1,r=0;r<e.C.length;r++)if(e.C[r]===t){e.C.splice(r,1),t.P=null,n=!0;break}if(!n)throw new Error("del: AST node not found in childs")}),this}},{key:"childs",value:function(){if(arguments.length>2)throw new Error("childs: invalid number of arguments");if(2===arguments.length&&"number"==typeof(arguments.length<=0?void 0:arguments[0])&&"number"==typeof(arguments.length<=1?void 0:arguments[1]))return this.C.slice(arguments.length<=0?void 0:arguments[0],arguments.length<=1?void 0:arguments[1]);if(1===arguments.length&&"number"==typeof(arguments.length<=0?void 0:arguments[0]))return this.C.slice(arguments.length<=0?void 0:arguments[0]);if(0===arguments.length)return this.C;throw new Error("childs: invalid type of arguments")}},{key:"child",value:function(e){if("number"!=typeof e)throw new Error("child: invalid argument");return e<this.C.length?this.C[e]:null}},{key:"parent",value:function(){return this.P}},{key:"serialize",value:function(){return this.ctx.__serialize(this)}}]),e}();n.default=u},{}],2:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,o(r.key),r)}}function o(e){var t=function(e,t){if("object"!==r(e)||null===e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var i=n.call(e,t||"default");if("object"!==r(i))return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"===r(t)?t:String(t)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var u={mid:{unicode:String.fromCharCode(9500),ascii:"+"},last:{unicode:String.fromCharCode(9492),ascii:"+"},down:{unicode:String.fromCharCode(9474),ascii:"|"},left:{unicode:String.fromCharCode(9472),ascii:"-"}},a=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&i(e.prototype,t),n&&i(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"dump",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1/0,t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:function(e,t){return t},n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],i="",o=this;return this.walk(function(a,f){if(!(f>e)){if(f>0){var l=function(e){var t=0,n=0;return null!==e.P&&(t=e.P.C.indexOf(e),n=e.P.C.length-1),{nth:t,max:n}},c=l(a),s=c.nth,y=c.max,h=" ";h=n?"".concat(u.left.unicode).concat(u.left.unicode).concat(h):"".concat(u.left.ascii).concat(u.left.ascii).concat(h),h=s<y?"".concat(n?u.mid.unicode:u.mid.ascii).concat(h):"".concat(n?u.last.unicode:u.last.ascii).concat(h);for(var d=a.P;null!==d&&d!==o;d=d.P)if(null!==d.P){var v=l(d);h=v.nth<v.max?"".concat(n?u.down.unicode:u.down.ascii,"   ").concat(h):"    ".concat(h)}i+=t("tree",h)}i+=t("type",a.T)+" ";var p=Object.keys(a.A).filter(function(e){return!e.match(/^__/)});if(p.length>0){i+=t("parenthesis","(");var b=!0;p.forEach(function(e){b?b=!1:i+=t("comma",",")+" ",i+=t("key",e)+t("colon",":")+" ";var n=a.A[e];switch(r(n)){case"boolean":case"number":i+=t("value",n.toString());break;case"string":var o=function(e){return e.charCodeAt(0).toString(16).toUpperCase()};i+=t("value",'"'+n.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+o(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+o(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+o(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+o(e)})+'"');break;case"object":n instanceof RegExp?i+=t("value","/"+n.source+"/"):i+=t("value",JSON.stringify(n));break;default:i+=t("value",JSON.stringify(n))}}),i+=t("parenthesis",")")+" "}i+=t("position",t("bracket","[")+t("line",a.L.L)+t("slash",",")+t("column",a.L.C)+t("bracket","]")),i+="\n"}},"downward"),i}}]),e}();n.default=a},{}],3:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,o(r.key),r)}}function o(e){var t=function(e,t){if("object"!==r(e)||null===e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var i=n.call(e,t||"default");if("object"!==r(i))return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"===r(t)?t:String(t)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var u=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&i(e.prototype,t),n&&i(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"merge",value:function(e){var t=this,n=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};if(null===e)return this;if(!this.ctx.isA(e))throw new Error("merge: invalid AST node argument");if(n){var i=e.pos();this.pos(i.line,i.column,i.offset)}e.attrs().forEach(function(n){var i=void 0!==r[n]?r[n]:n;null!==i&&t.set(i,e.get(n))}),e.childs().forEach(function(n){e.del(n),t.add(n)});var o=e.parent();return null!==o&&o.del(e),this}}]),e}();n.default=u},{}],4:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,o(r.key),r)}}function o(e){var t=function(e,t){if("object"!==r(e)||null===e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var i=n.call(e,t||"default");if("object"!==r(i))return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"===r(t)?t:String(t)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var u=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&i(e.prototype,t),n&&i(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,null,[{key:"serialize",value:function(e,t){if(!e.isA(t))throw new Error("serialize: not an ASTy node");return JSON.stringify({ASTy:function e(t){var n={T:t.T,L:{L:t.L.L,C:t.L.C,O:t.L.O}},i=Object.keys(t.A);return i.length>0&&(n.A={},i.forEach(function(e){var i=t.A[e];switch(r(i)){case"boolean":case"number":case"string":n.A[e]=i;break;default:n.A[e]=JSON.parse(JSON.stringify(i))}})),t.C.length>0&&(n.C=t.C.map(function(t){return e(t)})),n}(t)})}},{key:"unserialize",value:function(e,t){var n=JSON.parse(t);if("object"!==r(n)||"object"!==r(n.ASTy))throw new Error("unserialize: not an ASTy JSON export");return function t(n){var i=e.create(n.T);return i.pos(n.L.L,n.L.C,n.L.O),"object"===r(n.A)&&Object.keys(n.A).forEach(function(e){var t=n.A[e];switch(r(t)){case"boolean":case"number":case"string":i.set(e,t);break;default:i.set(e,JSON.parse(JSON.stringify(t)))}}),"object"===r(n.C)&&n.C instanceof Array&&i.add(n.C.map(function(e){return t(e)})),i}(n.ASTy)}}]),e}();n.default=u},{}],5:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var r={major:1,minor:8,micro:19,date:20230827};n.default=r},{}],6:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,o(r.key),r)}}function o(e){var t=function(e,t){if("object"!==r(e)||null===e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var i=n.call(e,t||"default");if("object"!==r(i))return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"===r(t)?t:String(t)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var u=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&i(e.prototype,t),n&&i(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"walk",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"downward";return function n(r,i,o){"downward"!==t&&"both"!==t||e(r,i,o,"downward"),r.C.forEach(function(e){n(e,i+1,r)}),"upward"!==t&&"both"!==t||e(r,i,o,"upward")}(this,0,null),this}}]),e}();n.default=u},{}],7:[function(e,t,n){"use strict";var r=l(e("./asty-base.js")),i=l(e("./asty-merge.js")),o=l(e("./asty-walk.js")),u=l(e("./asty-dump.js")),a=l(e("./asty-serialize.js")),f=l(e("./asty-version.js"));function l(e){return e&&e.__esModule?e:{default:e}}function c(e){return(c="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function s(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function y(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,d(r.key),r)}}function h(e,t,n){return t&&y(e.prototype,t),n&&y(e,n),Object.defineProperty(e,"prototype",{writable:!1}),e}function d(e){var t=function(e,t){if("object"!==c(e)||null===e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var r=n.call(e,t||"default");if("object"!==c(r))return r;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"===c(t)?t:String(t)}var v=function(){function e(){var t=this;return s(this,e),this.ASTYNode=h(function e(){s(this,e)}),[[r.default,"init","create","type","pos","set","unset","get","attrs","nth","ins","add","del","childs","child","parent","serialize"],[i.default,"merge"],[o.default,"walk"],[u.default,"dump"]].forEach(function(e){var n=e[0].prototype;e.slice(1).forEach(function(e){t.ASTYNode.prototype[e]=n[e]})}),this}return h(e,[{key:"version",value:function(){return f.default}},{key:"extend",value:function(e){for(var t in e)Object.prototype.hasOwnProperty.call(e,t)&&(this.ASTYNode.prototype[t]=e[t]);return this}},{key:"create",value:function(e,t,n){return(new this.ASTYNode).init(this,e,t,n)}},{key:"isA",value:function(e){return"object"===c(e)&&e instanceof this.ASTYNode&&"boolean"==typeof e.ASTy&&!0===e.ASTy}},{key:"__serialize",value:function(t){return e.serialize(t)}}],[{key:"serialize",value:function(e){return a.default.serialize(e.ctx,e)}},{key:"unserialize",value:function(e){return a.default.unserialize(new this,e)}}]),e}();t.exports=v},{"./asty-base.js":1,"./asty-dump.js":2,"./asty-merge.js":3,"./asty-serialize.js":4,"./asty-version.js":5,"./asty-walk.js":6}]},{},[1,2,3,4,5,6,7])(7)});
}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],2:[function(_dereq_,module,exports){
(function (global){(function (){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this).CacheLRU=e()}}(function(){return function(){return function e(t,i,n){function r(u,s){if(!i[u]){if(!t[u]){var l="function"==typeof _dereq_&&_dereq_;if(!s&&l)return l(u,!0);if(o)return o(u,!0);var h=new Error("Cannot find module '"+u+"'");throw h.code="MODULE_NOT_FOUND",h}var a=i[u]={exports:{}};t[u][0].call(a.exports,function(e){return r(t[u][1][e]||e)},a,a.exports,e,t,i,n)}return i[u].exports}for(var o="function"==typeof _dereq_&&_dereq_,u=0;u<n.length;u++)r(n[u]);return r}}()({1:[function(e,t,i){"use strict";function n(e,t){for(var i=0;i<t.length;i++){var n=t[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var r=function(){function e(){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this._index={},this._LRU={newer:null},this._MRU={older:null},this._LRU.newer=this._MRU,this._MRU.older=this._LRU,this._cur=0,this._max=1/0,this._dispose=function(){},this}return function(e,t,i){t&&n(e.prototype,t),i&&n(e,i)}(e,[{key:"limit",value:function(e){var t=this._max;return arguments.length>0&&(this._max=e,this._purge()),t}},{key:"dispose",value:function(e){return this._dispose=e,this}},{key:"length",value:function(){return this._cur}},{key:"keys",value:function(){return this.each(function(e,t){this.push(t)},[])}},{key:"values",value:function(){return this.each(function(e){this.push(e)},[])}},{key:"each",value:function(e,t){arguments<2&&(t=this);for(var i=0,n=this._MRU.older;n!==this._LRU;)e.call(t,n.val,n.key,i++),n=n.older;return t}},{key:"has",value:function(e){var t=this._index[e];return void 0!==t&&t.expires>=Date.now()}},{key:"peek",value:function(e){var t=this._index[e];if(void 0!==t){if(!(t.expires<Date.now()))return t.val;this.del(t.key)}}},{key:"touch",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("touch: no such item");return this._promote(t),this}},{key:"get",value:function(e){var t=this._index[e];if(void 0!==t){if(!(t.expires<Date.now()))return this._promote(t),t.val;this.del(t.key)}}},{key:"set",value:function(e,t,i){arguments.length<3&&(i=1/0),i+=Date.now();var n=this._index[e];if(void 0===n)n={older:null,newer:null,key:e,val:t,expires:i},this._index[e]=n,this._attach(n),this._cur++,this._purge();else{var r=n.val;n.val=t,this._promote(n),this._dispose.call(void 0,n.key,r,"set")}return this}},{key:"del",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("del: no such item");return delete this._index[e],this._detach(t),this._cur--,this._dispose.call(void 0,e,t.val,"del"),this}},{key:"clear",value:function(){for(;this._cur>0;)this.del(this._LRU.newer.key);return this}},{key:"_purge",value:function(){for(;this._cur>this._max;)this.del(this._LRU.newer.key)}},{key:"_promote",value:function(e){this._detach(e),this._attach(e)}},{key:"_detach",value:function(e){e.older.newer=e.newer,e.newer.older=e.older,e.older=null,e.newer=null}},{key:"_attach",value:function(e){e.older=this._MRU.older,e.newer=this._MRU,e.newer.older=e,e.older.newer=e}}]),e}();t.exports=r},{}]},{},[1])(1)});
}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],3:[function(_dereq_,module,exports){
(function (global){(function (){
!function(e,n,r){"object"==typeof module&&"object"==typeof module.exports?module.exports=r():"function"==typeof define&&void 0!==define.amd?define("PEGUtil",function(){return r()}):e.PEGUtil=r()}("undefined"!=typeof global?global:"undefined"!=typeof window?window:this,0,function(){var e={makeAST:function(e,n){return function(){return n.util.__makeAST.call(null,e().start.line,e().start.column,e().start.offset,arguments)}},makeUnroll:function(e,n){return function(r,t,o){if("object"!=typeof t||!(t instanceof Array))throw new n.util.__SyntaxError("unroll: invalid list argument for unrolling",typeof t,"Array",e());if(void 0!==o){"number"==typeof o&&(o=[o]);var l=[];null!==r&&l.push(r);for(var a=0;a<t.length;a++)for(var i=0;i<o.length;i++)l.push(t[a][o[i]]);return l}return null!==r&&t.unshift(r),t}}},n=function(e,n){var r=e.length,t=n-20;t<0&&(t=0);var o=n+20;o>r&&(o=r);var l=function(e){return e.charCodeAt(0).toString(16).toUpperCase()},a=function(e,n,r){return e.substr(n,r).replace(/\\/g,"\\\\").replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+l(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+l(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+l(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+l(e)})};return{prolog:a(e,t,n-t),token:a(e,n,1),epilog:a(e,n+1,o-(n+1))}};return e.parse=function(r,t,o){if("object"!=typeof r)throw new Error("invalid parser object (not an object)");if("function"!=typeof r.parse)throw new Error('invalid parser object (no "parse" function)');if("string"!=typeof t)throw new Error("invalid input text (not a string)");if(void 0!==o&&"object"!=typeof o)throw new Error("invalid options (not an object)");void 0===o&&(o={});var l={ast:null,error:null};try{var a;a="function"==typeof o.makeAST?o.makeAST:function(e,n){return{line:e().start.line,column:e().start.column,offset:e().start.offset,args:n}},o.util={makeUnroll:e.makeUnroll,makeAST:e.makeAST,__makeAST:a,__SyntaxError:r.SyntaxError},l.ast=r.parse(t,o),l.error=null}catch(e){if(l.ast=null,e instanceof r.SyntaxError){var i=function(e,n){return void 0!==e?e:n};l.error={line:i(e.location.start.line,0),column:i(e.location.start.column,0),message:e.message,found:i(e.found,""),expected:i(e.expected,""),location:n(t,i(e.location.start.offset,0))}}else l.error={line:0,column:0,message:e.message,found:"",expected:"",location:n("",0)}}return l},e.errorMessage=function(e,n){for(var r=e.location,t="line "+e.line+" (column "+e.column+"): ",o="",l=0;l<t.length+r.prolog.length;l++)o+="-";return t+r.prolog+r.token+r.epilog+"\n"+o+"^\n"+e.message+(n?"":"\n")},e});
}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],4:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!==_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterASTY=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"boolean"==typeof e.ASTy}},{key:"getParentNode",value:function(e){return e.parent()}},{key:"getChildNodes",value:function(e){return e.childs()}},{key:"getNodeType",value:function(e){return e.type()}},{key:"getNodeAttrNames",value:function(e){return e.attrs()}},{key:"getNodeAttrValue",value:function(e,t){return e.get(t)}}]),e}();
},{}],5:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var o=0;o<t.length;o++){var n=t[o];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,_toPropertyKey(n.key),n)}}function _createClass(e,t,o){return t&&_defineProperties(e.prototype,t),o&&_defineProperties(e,o),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var o=e[Symbol.toPrimitive];if(void 0!==o){var n=o.call(e,t||"default");if("object"!==_typeof(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterCheerio=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return!("object"!==_typeof(e)||null===e||("object"===("undefined"==typeof Element?"undefined":_typeof(Element))&&e instanceof Element||"string"!=typeof e.tagName||""===e.tagName)&&("object"===("undefined"==typeof Document?"undefined":_typeof(Document))&&e instanceof Document||"string"!=typeof e.type||"root"!==e.type))}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&e.childNodes instanceof Array?e.childNodes:[]}},{key:"getNodeType",value:function(e){return e.tagName||"#".concat(e.type||"unknown")}},{key:"getNodeAttrNames",value:function(e){var t=["value"];return"object"===_typeof(e.attribs)&&(t=t.concat(Object.keys(e.attribs))),t}},{key:"getNodeAttrValue",value:function(e,t){var o;return"value"===t?o=e.nodeValue:"object"===_typeof(e.attribs)&&(o=e.attribs[t]),o}}]),e}();
},{}],6:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!==_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterGraphQL=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"string"==typeof e.kind&&""!==e.kind}},{key:"getParentNode",value:function(e,t){throw new Error("GraphQL AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var r=this,o=[],n=function(e,t){Object.prototype.hasOwnProperty.call(e,t)&&r.taste(e[t])?o.push(e[t]):Object.prototype.hasOwnProperty.call(e,t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){r.taste(e)&&o.push(e)})};if("*"===t)for(var i in e)n(e,i);else void 0!==e[t]&&n(e,t);return o}},{key:"getNodeType",value:function(e){return e.kind}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&"object"!==_typeof(e[r])&&"kind"!==r&&"loc"!==r&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"object"!==_typeof(e[t])&&"kind"!==t&&"loc"!==t?e[t]:void 0}}]),e}();
},{}],7:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!==_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterJSON=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e}},{key:"getParentNode",value:function(e,t){throw new Error("JSON does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var r=this,o=[],n=function(e,t){Object.prototype.hasOwnProperty.call(e,t)&&r.taste(e[t])?o.push(e[t]):Object.prototype.hasOwnProperty.call(e,t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){r.taste(e)&&o.push(e)})};if("*"===t)for(var i in e)n(e,i);else void 0!==e[t]&&n(e,t);return o}},{key:"getNodeType",value:function(e){return null===e?"Null":e instanceof Boolean?"Boolean":e instanceof Number?"Number":e instanceof String?"String":"object"===_typeof(e)?e instanceof Array?"Array":"function"==typeof e.constructor&&"string"==typeof e.constructor.name?e.constructor.name:"Object":"Unknown"}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&"object"!==_typeof(e[r])&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"object"!==_typeof(e[t])?e[t]:void 0}}]),e}();
},{}],8:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!==_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterMozAST=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"string"==typeof e.type&&""!==e.type}},{key:"getParentNode",value:function(e,t){if("*"!==t&&"parent"!==t)throw new Error('no such axis named "'+t+'" for walking to parent nodes');if(void 0!==e.parent)return e.parent;throw new Error("Your Mozilla SpiderMonkey AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var r=this,o=[],n=function(e,t){Object.prototype.hasOwnProperty.call(e,t)&&r.taste(e[t])?o.push(e[t]):Object.prototype.hasOwnProperty.call(e,t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){r.taste(e)&&o.push(e)})};if("*"===t)for(var i in e)n(e,i);else void 0!==e[t]&&n(e,t);return o}},{key:"getNodeType",value:function(e){return e.type}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&"object"!==_typeof(e[r])&&"type"!==r&&"loc"!==r&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"object"!==_typeof(e[t])&&"type"!==t&&"loc"!==t?e[t]:void 0}}]),e}();
},{}],9:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!==_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterParse5=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&!("object"===("undefined"==typeof Node?"undefined":_typeof(Node))&&e instanceof Node)&&"string"==typeof e.nodeName&&""!==e.nodeName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&e.childNodes instanceof Array?e.childNodes:[]}},{key:"getNodeType",value:function(e){return e.nodeName}},{key:"getNodeAttrNames",value:function(e){var t=["value"];return"object"===_typeof(e.attrs)&&e.attrs instanceof Array&&(t=t.concat(e.attrs.map(function(e){return e.name}))),t}},{key:"getNodeAttrValue",value:function(e,t){var r;if("value"===t)r=e.value;else if("object"===_typeof(e.attrs)&&e.attrs instanceof Array){var o=e.attrs.filter(function(e){return e.name===t}).map(function(e){return e.value});1===o.length&&(r=o[0])}return r}}]),e}();
},{}],10:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!==_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterUniST=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"string"==typeof e.type&&""!==e.type}},{key:"getParentNode",value:function(e){if("object"===_typeof(e.parent)&&null!==e.parent)return e.parent;throw new Error("Your UniST AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.children)&&e.children instanceof Array?e.children:[]}},{key:"getNodeType",value:function(e){return e.type}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&"type"!==r&&"data"!==r&&"position"!==r&&"children"!==r&&"object"!==_typeof(e[r])&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"type"!==t&&"data"!==t&&"position"!==t&&"children"!==t&&"object"!==_typeof(e[t])?e[t]:void 0}}]),e}();
},{}],11:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var o=0;o<t.length;o++){var r=t[o];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,_toPropertyKey(r.key),r)}}function _createClass(e,t,o){return t&&_defineProperties(e.prototype,t),o&&_defineProperties(e,o),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var o=e[Symbol.toPrimitive];if(void 0!==o){var r=o.call(e,t||"default");if("object"!==_typeof(r))return r;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterXMLDOM=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===("undefined"==typeof Node?"undefined":_typeof(Node))&&null!==e&&e instanceof Node&&"object"===_typeof(e)&&"number"==typeof e.nodeType&&"string"==typeof e.nodeName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&null!==e.childNodes&&e.hasChildNodes()?Array.prototype.slice.call(e.childNodes,0):[]}},{key:"getNodeType",value:function(e){return"string"==typeof e.nodeName?e.nodeName:"unknown"}},{key:"getNodeAttrNames",value:function(e){return"object"===_typeof(e.attributes)&&null!==e.attributes&&e.hasAttributes()?Array.prototype.slice.call(e.attributes,0).map(function(e){return e.nodeName}):[]}},{key:"getNodeAttrValue",value:function(e,t){return"object"===_typeof(e.attributes)&&null!==e.attributes&&e.hasAttributes()?e.getAttribute(t):void 0}}]),e}();
},{}],12:[function(_dereq_,module,exports){
"use strict";function _typeof(t){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function _classCallCheck(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function _defineProperties(t,e){for(var r=0;r<e.length;r++){var o=e[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(t,_toPropertyKey(o.key),o)}}function _createClass(t,e,r){return e&&_defineProperties(t.prototype,e),r&&_defineProperties(t,r),Object.defineProperty(t,"prototype",{writable:!1}),t}function _toPropertyKey(t){var e=_toPrimitive(t,"string");return"symbol"===_typeof(e)?e:String(e)}function _toPrimitive(t,e){if("object"!==_typeof(t)||null===t)return t;var r=t[Symbol.toPrimitive];if(void 0!==r){var o=r.call(t,e||"default");if("object"!==_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapter=exports.default=function(){function t(){return _classCallCheck(this,t),this._adapters=[],this}return _createClass(t,[{key:"register",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this._adapters.unshift({adapter:t,force:e}),this}},{key:"unregister",value:function(t){if(void 0===t)this._adapters=[];else{for(var e=[],r=0;r<this._adapters.length;r++)this._adapters[r].adapter!==t&&e.push(this._adapters[r]);this._adapters=e}return this}},{key:"select",value:function(t){for(var e=0;e<this._adapters.length;e++)if(this._adapters[e].force||this._adapters[e].adapter.taste(t))return this._adapters[e].adapter}}]),t}();
},{}],13:[function(_dereq_,module,exports){
"use strict";function _typeof(t){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _pos=function(t,n){var e=t.getParentNode(n,"*");if(null===e)return 1;for(var r=t.getChildNodes(e,"*"),o=0;o<r.length;o++)if(r[o]===n)return o+1;throw new Error("cannot find myself")},parents=function(t,n){for(var e=[];null!==(n=t.getParentNode(n,"*"));)e.push(n);return e},stdfuncs={type:function(t,n){return t.getNodeType(n)},attrs:function(t,n,e){return void 0===e&&(e=" "),e+t.getNodeAttrNames(n).join(e)+e},depth:function(t,n){for(var e=1,r=n;null!==(r=t.getParentNode(r,"*"));)e++;return e},pos:function(t,n){return _pos(t,n)},nth:function(t,n,e){e=parseInt(e,10);var r=t.getParentNode(n,"*");if(null!==r){var o=t.getChildNodes(r,"*");e<0&&(e=o.length-(e+1));for(var u=0;u<o.length;u++)if(o[u]===n)return u+1===e;return!1}return 1===e},first:function(t,n){return stdfuncs.nth(t,n,1)},last:function(t,n){return stdfuncs.nth(t,n,-1)},count:function(t,n,e){return"object"===_typeof(e)&&e instanceof Array?e.length:"object"===_typeof(e)?Object.keys(e).length:"string"==typeof e?e.length:String(e).length},below:function(t,n,e){if(!t.taste(e))throw new Error('invalid argument to function "below" (node expected)');for(var r=n;null!==(r=t.getParentNode(r,"*"));)if(r===e)return!0;return!1},follows:function(t,n,e){if(!t.taste(e))throw new Error('invalid argument to function "follows" (node expected)');if(n===e)return!1;var r,o=[n].concat(parents(t,n)).reverse(),u=[e].concat(parents(t,e)).reverse(),f=Math.min(o.length,u.length);for(r=0;r<f&&o[r]===u[r];r++);if(0===r)throw new Error("internal error: root nodes have to be same same");return r===f?u.length<o.length:_pos(t,o[r])>_pos(t,u[r])},in:function(t,n,e){if(!("object"===_typeof(e)&&e instanceof Array))throw new Error('invalid argument to function "in" (array expected)');for(var r=0;r<e.length;r++)if(e[r]===n)return!0;return!1},substr:function(t,n,e,r,o){return String(e).substr(r,o)},index:function(t,n,e,r,o){return String(e).indexOf(r,o)},trim:function(t,n,e){return String(e).trim()},lc:function(t,n,e){return String(e).toLowerCase()},uc:function(t,n,e){return String(e).toUpperCase()}},_default=exports.default=stdfuncs;
},{}],14:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!==_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQFuncs=exports.default=function(){function e(){return _classCallCheck(this,e),this._funcs={},this}return _createClass(e,[{key:"register",value:function(e,t){this._funcs[e]=t}},{key:"run",value:function(e,t){var r=this._funcs[e];if("function"!=typeof r)throw new Error('invalid function "'+e+'"');return r.apply(null,t)}}]),e}();
},{}],15:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _astqUtil=_interopRequireDefault(_dereq_("./astq-util.js")),_astqQueryTrace=_interopRequireDefault(_dereq_("./astq-query-trace.js"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,_toPropertyKey(a.key),a)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var a=r.call(e,t||"default");if("object"!==_typeof(a))return a;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&_setPrototypeOf(e,t)}function _setPrototypeOf(e,t){return(_setPrototypeOf=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e})(e,t)}function _createSuper(e){var t=_isNativeReflectConstruct();return function(){var r,a=_getPrototypeOf(e);if(t){var i=_getPrototypeOf(this).constructor;r=Reflect.construct(a,arguments,i)}else r=a.apply(this,arguments);return _possibleConstructorReturn(this,r)}}function _possibleConstructorReturn(e,t){if(t&&("object"===_typeof(t)||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return _assertThisInitialized(e)}function _assertThisInitialized(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function _isNativeReflectConstruct(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],function(){})),!0}catch(e){return!1}}function _getPrototypeOf(e){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}var ASTQQueryExec=exports.default=function(e){_inherits(r,_astqQueryTrace["default"]);var t=_createSuper(r);function r(e,a,i,n){var c;return _classCallCheck(this,r),(c=t.call(this)).adapter=e,c.params=a,c.funcs=i,c.trace=n,c}return _createClass(r,[{key:"execQuery",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[];return e.childs().forEach(function(e){a=a.concat(r.execPath(e,t))}),this.traceEnd(e,t,a),a}},{key:"execPath",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[t],i=[],n=!1;return e.childs().forEach(function(e){var t=[];a.forEach(function(a){t=t.concat(r.execStep(e,a))}),a=t,e.get("isResult")&&(n=!0,i=i.concat(a))}),this.traceEnd(e,t,a),n?i:a}},{key:"execStep",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.childs(),i=null,n=null,c=null,s=0;if(s<a.length&&"Axis"===a[s].type()&&(i=a[s++]),s<a.length&&"Match"===a[s].type()&&(n=a[s++]),s<a.length&&"Filter"===a[s].type()&&(c=a[s++]),null===n)throw new Error("no matching part in query step");var o=[],l=n.get("id"),u=function(e){var t=r.adapter.getNodeType(e);if("*"===l||l===t){var a=!0;null!==c&&(r.execFilter(c,e)||(a=!1)),a&&o.push(e)}};if(null!==i){var f=i.get("op"),h=i.get("type");if("/"===f)this.adapter.getChildNodes(t,h).forEach(function(e){return u(e)});else if("//"===f){this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){u(t),r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})}else if("./"===f)u(t),this.adapter.getChildNodes(t,h).forEach(function(e){return u(e)});else if(".//"===f){u(t);this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){u(t),r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})}else if("-/"===f){var d=this.adapter.getParentNode(t,"*");if(null!==d){for(var p=this.adapter.getChildNodes(d,h),x=null,y=0;y<p.length&&p[y]!==t;y++)x=p[y];null!==x&&u(x)}}else if("-//"===f){var g=this.adapter.getParentNode(t,"*");if(null!==g){for(var v=this.adapter.getChildNodes(g,h),E=0;E<v.length&&v[E]!==t;E++);for(E--;E>=0;E--)u(v[E])}}else if("+/"===f){var b=this.adapter.getParentNode(t,"*");if(null!==b){var _,m=this.adapter.getChildNodes(b,h);for(_=0;_<m.length&&m[_]!==t;_++);_<m.length&&u(m[++_])}}else if("+//"===f){var k=this.adapter.getParentNode(t,"*");if(null!==k){var q,P=this.adapter.getChildNodes(k,h);for(q=0;q<P.length&&P[q]!==t;q++);if(q<P.length)for(q++;q<P.length;q++)u(P[q])}}else if("~/"===f){var U=this.adapter.getParentNode(t,"*");if(null!==U){var C,N=this.adapter.getChildNodes(U,h);for(C=0;C<N.length&&N[C]!==t;C++);C>0&&u(N[C-1]),C<N.length-1&&u(N[C+1])}}else if("~//"===f){var w=this.adapter.getParentNode(t,"*");if(null!==w)for(var B=this.adapter.getChildNodes(w,h),O=0;O<B.length;O++)B[O]!==t&&u(B[O])}else if("../"===f){var R=this.adapter.getParentNode(t,h);null!==R&&u(R)}else if("..//"===f)for(var S=t;;){var j=this.adapter.getParentNode(S,h);if(null===j)break;u(j),S=j}else if("<//"===f){for(var L={sentinel:t,take:!0};;){var T=this.adapter.getParentNode(t,"*");if(null===T)break;t=T}t!==L.sentinel&&(u(t),this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){t===L.sentinel&&(L.take=!1),L.take&&u(t),L.take&&r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})),o=o.reverse()}else if(">//"===f){for(var A={sentinel:t,take:!1};;){var F=this.adapter.getParentNode(t,"*");if(null===F)break;t=F}this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){A.take&&u(t),t===A.sentinel&&(A.take=!0),r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})}}else u(t);return this.traceEnd(e,t,o),o}},{key:"execFilter",value:function(e,t){this.traceBegin(e,t);var r=e.childs()[0],a=this.execExpr(r,t);return a=_astqUtil.default.truthy(a),this.traceEnd(e,t,a),a}},{key:"execExpr",value:function(e,t){switch(e.type()){case"ConditionalBinary":return this.execExprConditionalBinary(e,t);case"ConditionalTernary":return this.execExprConditionalTernary(e,t);case"Logical":return this.execExprLogical(e,t);case"Bitwise":return this.execExprBitwise(e,t);case"Relational":return this.execExprRelational(e,t);case"Arithmetical":return this.execExprArithmetical(e,t);case"Unary":return this.execExprUnary(e,t);case"FuncCall":return this.execExprFuncCall(e,t);case"Attribute":return this.execExprAttribute(e,t);case"Param":return this.execExprParam(e,t);case"LiteralString":return this.execExprLiteralString(e,t);case"LiteralRegExp":return this.execExprLiteralRegExp(e,t);case"LiteralNumber":return this.execExprLiteralNumber(e,t);case"LiteralValue":return this.execExprLiteralValue(e,t);case"Path":return this.execExprPath(e,t)}}},{key:"execExprConditionalBinary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return _astqUtil.default.truthy(r)||(r=this.execExpr(e.childs()[1],t)),this.traceEnd(e,t,r),r}},{key:"execExprConditionalTernary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return r=_astqUtil.default.truthy(r)?this.execExpr(e.childs()[1],t):this.execExpr(e.childs()[2],t),this.traceEnd(e,t,r),r}},{key:"execExprLogical",value:function(e,t){this.traceBegin(e,t);var r=!1;switch(e.get("op")){case"&&":(r=_astqUtil.default.truthy(this.execExpr(e.childs()[0],t)))&&(r=r&&_astqUtil.default.truthy(this.execExpr(e.childs()[1],t)));break;case"||":(r=_astqUtil.default.truthy(this.execExpr(e.childs()[0],t)))||(r=r||_astqUtil.default.truthy(this.execExpr(e.childs()[1],t)))}return this.traceEnd(e,t,r),r}},{key:"execExprBitwise",value:function(e,t){this.traceBegin(e,t);var r,a=_astqUtil.default.coerce(this.execExpr(e.childs()[0],t),"number"),i=_astqUtil.default.coerce(this.execExpr(e.childs()[1],t),"number");switch(e.get("op")){case"&":r=a&i;break;case"|":r=a|i;break;case"<<":r=a<<i;break;case">>":r=a>>i}return this.traceEnd(e,t,r),r}},{key:"execExprRelational",value:function(e,t){this.traceBegin(e,t);var r,a=this.execExpr(e.childs()[0],t),i=this.execExpr(e.childs()[1],t);switch(e.get("op")){case"==":r=a===i;break;case"!=":r=a!==i;break;case"<=":r=_astqUtil.default.coerce(a,"number")<=_astqUtil.default.coerce(i,"number");break;case">=":r=_astqUtil.default.coerce(a,"number")>=_astqUtil.default.coerce(i,"number");break;case"<":r=_astqUtil.default.coerce(a,"number")<_astqUtil.default.coerce(i,"number");break;case">":r=_astqUtil.default.coerce(a,"number")>_astqUtil.default.coerce(i,"number");break;case"=~":r=null!==_astqUtil.default.coerce(a,"string").match(_astqUtil.default.coerce(i,"regexp"));break;case"!~":r=null===_astqUtil.default.coerce(a,"string").match(_astqUtil.default.coerce(i,"regexp"))}return this.traceEnd(e,t,r),r}},{key:"execExprArithmetical",value:function(e,t){this.traceBegin(e,t);var r,a=this.execExpr(e.childs()[0],t),i=this.execExpr(e.childs()[1],t);switch(e.get("op")){case"+":r="string"==typeof a?a+_astqUtil.default.coerce(i,"string"):_astqUtil.default.coerce(a,"number")+_astqUtil.default.coerce(i,"number");break;case"-":r=_astqUtil.default.coerce(a,"number")+_astqUtil.default.coerce(i,"number");break;case"*":r=_astqUtil.default.coerce(a,"number")*_astqUtil.default.coerce(i,"number");break;case"/":r=_astqUtil.default.coerce(a,"number")/_astqUtil.default.coerce(i,"number");break;case"%":r=_astqUtil.default.coerce(a,"number")%_astqUtil.default.coerce(i,"number");break;case"**":r=Math.pow(_astqUtil.default.coerce(a,"number"),_astqUtil.default.coerce(i,"number"))}return this.traceEnd(e,t,r),r}},{key:"execExprUnary",value:function(e,t){this.traceBegin(e,t);var r,a=this.execExpr(e.childs()[0],t);switch(e.get("op")){case"!":r=!_astqUtil.default.coerce(a,"boolean");break;case"~":r=~_astqUtil.default.coerce(a,"number")}return this.traceEnd(e,t,r),r}},{key:"execExprFuncCall",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.get("id"),i=[this.adapter,t];e.childs().forEach(function(e){i.push(r.execExpr(e,t))});var n=this.funcs.run(a,i);return this.traceEnd(e,t,n),n}},{key:"execExprAttribute",value:function(e,t){this.traceBegin(e,t);var r=e.get("id"),a=this.adapter.getNodeAttrValue(t,r);return this.traceEnd(e,t,a),a}},{key:"execExprParam",value:function(e,t){this.traceBegin(e,t);var r=e.get("id");if(void 0===this.params[r])throw new Error('invalid parameter "'+r+'"');var a=this.params[r];return this.traceEnd(e,t,a),a}},{key:"execExprLiteralString",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralRegExp",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralNumber",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralValue",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprPath",value:function(e,t){this.traceBegin(e,t);var r=this.execPath(e,t);return this.traceEnd(e,t,r),r}}]),r}();
},{"./astq-query-trace.js":16,"./astq-util.js":18}],16:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _astqUtil=_interopRequireDefault(_dereq_("./astq-util.js"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!==_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}var ASTQQueryTrace=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,[{key:"prefixOf",value:function(e,t){for(var r=0,o=e;null!==(o=o.parent());)r++;var i=_astqUtil.default.pad("",4*r);for(r=0,o=t;null!==(o=this.adapter.getParentNode(o,"*"));)r++;return{prefix1:i,prefix2:_astqUtil.default.pad("",4*r)}}},{key:"traceBegin",value:function(e,t){if(this.trace){var r=this.prefixOf(e,t),o=r.prefix1,i=r.prefix2;console.log("ASTQ: execute: | "+_astqUtil.default.pad(o+e.type()+" (",-60)+" | "+i+this.adapter.getNodeType(t))}}},{key:"traceEnd",value:function(e,t,r){var o=this;if(this.trace){var i,n=this.prefixOf(e,t),a=n.prefix1,f=n.prefix2;void 0===r?i="undefined":"object"===_typeof(r)&&r instanceof Array?(i="[",r.forEach(function(e){i+="node("+o.adapter.getNodeType(e)+"),"}),i=i.replace(/,$/,"")+"]"):i=_typeof(r)+"("+r+")",i.length>60&&(i=i.substr(0,60)+"..."),console.log("ASTQ: execute: | "+_astqUtil.default.pad(a+"): "+i,-60)+" | "+f+this.adapter.getNodeType(t))}}}]),e}();
},{"./astq-util.js":18}],17:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _asty=_interopRequireDefault(_dereq_("asty")),_pegjsUtil=_interopRequireDefault(_dereq_("pegjs-util")),_astqQueryExec=_interopRequireDefault(_dereq_("./astq-query-exec.js"));function _interopRequireDefault(t){return t&&t.__esModule?t:{default:t}}function _typeof(t){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function _classCallCheck(t,r){if(!(t instanceof r))throw new TypeError("Cannot call a class as a function")}function _defineProperties(t,r){for(var e=0;e<r.length;e++){var n=r[e];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,_toPropertyKey(n.key),n)}}function _createClass(t,r,e){return r&&_defineProperties(t.prototype,r),e&&_defineProperties(t,e),Object.defineProperty(t,"prototype",{writable:!1}),t}function _toPropertyKey(t){var r=_toPrimitive(t,"string");return"symbol"===_typeof(r)?r:String(r)}function _toPrimitive(t,r){if("object"!==_typeof(t)||null===t)return t;var e=t[Symbol.toPrimitive];if(void 0!==e){var n=e.call(t,r||"default");if("object"!==_typeof(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===r?String:Number)(t)}var ASTQQueryParse=function(){function t(r,e,n,u){this.message=r,this.expected=e,this.found=n,this.location=u,this.name="SyntaxError","function"==typeof Error.captureStackTrace&&Error.captureStackTrace(this,t)}return function(t,r){function e(){this.constructor=t}e.prototype=r.prototype,t.prototype=new e}(t,Error),t.buildMessage=function(t,r){var e={literal:function(t){return'"'+u(t.text)+'"'},class:function(t){var r,e="";for(r=0;r<t.parts.length;r++)e+=t.parts[r]instanceof Array?s(t.parts[r][0])+"-"+s(t.parts[r][1]):s(t.parts[r]);return"["+(t.inverted?"^":"")+e+"]"},any:function(t){return"any character"},end:function(t){return"end of input"},other:function(t){return t.description}};function n(t){return t.charCodeAt(0).toString(16).toUpperCase()}function u(t){return t.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,function(t){return"\\x0"+n(t)}).replace(/[\x10-\x1F\x7F-\x9F]/g,function(t){return"\\x"+n(t)})}function s(t){return t.replace(/\\/g,"\\\\").replace(/\]/g,"\\]").replace(/\^/g,"\\^").replace(/-/g,"\\-").replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,function(t){return"\\x0"+n(t)}).replace(/[\x10-\x1F\x7F-\x9F]/g,function(t){return"\\x"+n(t)})}return"Expected "+function(t){var r,n,u,s=new Array(t.length);for(r=0;r<t.length;r++)s[r]=(u=t[r],e[u.type](u));if(s.sort(),s.length>0){for(r=1,n=1;r<s.length;r++)s[r-1]!==s[r]&&(s[n]=s[r],n++);s.length=n}switch(s.length){case 1:return s[0];case 2:return s[0]+" or "+s[1];default:return s.slice(0,-1).join(", ")+", or "+s[s.length-1]}}(t)+" but "+function(t){return t?'"'+u(t)+'"':"end of input"}(r)+" found."},{SyntaxError:t,parse:function(r,e){e=void 0!==e?e:{};var n,u={},s={query:Dn},o=Dn,a=function(t){return t},i=",",c=kn(",",!1),l=function(t,r){return du("Query").add(Au(t,r,3))},f=function(t,r){return du("Path").add(Au(t,r,1))},h="!",p=kn("!",!1),A=function(t,r,e,n){return du("Step").add(t,r,n).set(null!==e?{isResult:!0}:{})},d=Mn("axis"),x="//",b=kn("//",!1),g="/",v=kn("/",!1),P="-//",y=kn("-//",!1),m="-/",C=kn("-/",!1),_="+//",S=kn("+//",!1),w="+/",q=kn("+/",!1),E="~//",Q=kn("~//",!1),R="~/",T=kn("~/",!1),F="..//",L=kn("..//",!1),j="../",k=kn("../",!1),N=".//",M=kn(".//",!1),I="./",U=kn("./",!1),V="<//",z=kn("<//",!1),D=">//",O=kn(">//",!1),Z=function(t,r){return du("Axis").set({op:t,type:null!==r?r:"*"})},B=":",K=kn(":",!1),$=function(t){return t.get("id")},G=function(t){return t.get("value")},H=function(t){return du("Match").merge(t)},J=function(t){return du("Match").set({id:t.get("value")})},W="*",X=kn("*",!1),Y=function(){return du("Match").set({id:"*"})},tt="[",rt=kn("[",!1),et="]",nt=kn("]",!1),ut=function(t){return du("Filter").add(t)},st="?:",ot=kn("?:",!1),at=function(t,r){return du("ConditionalBinary").add(t,r)},it="?",ct=kn("?",!1),lt=function(t,r,e){return du("ConditionalTernary").add(t,r,e)},ft="||",ht=kn("||",!1),pt=function(t,r,e){return du("Logical").set({op:r}).add(t,e)},At="&&",dt=kn("&&",!1),xt="|",bt=kn("|",!1),gt=function(t,r,e){return du("Bitwise").set({op:r}).add(t,e)},vt="^",Pt=kn("^",!1),yt="&",mt=kn("&",!1),Ct="==",_t=kn("==",!1),St="!=",wt=kn("!=",!1),qt="<=",Et=kn("<=",!1),Qt=">=",Rt=kn(">=",!1),Tt="<",Ft=kn("<",!1),Lt=">",jt=kn(">",!1),kt="=~",Nt=kn("=~",!1),Mt="!~",It=kn("!~",!1),Ut=function(t,r,e){return du("Relational").set({op:r}).add(t,e)},Vt="<<",zt=kn("<<",!1),Dt=">>",Ot=kn(">>",!1),Zt="+",Bt=kn("+",!1),Kt="-",$t=kn("-",!1),Gt=function(t,r,e){return du("Arithmetical").set({op:r}).add(t,e)},Ht="**",Jt=kn("**",!1),Wt="%",Xt=kn("%",!1),Yt="~",tr=kn("~",!1),rr=function(t,r){return du("Unary").set({op:t}).add(r)},er="(",nr=kn("(",!1),ur=")",sr=kn(")",!1),or=function(t,r){return du("FuncCall").merge(t).add(r)},ar=function(t,r){return Au(t,r,3)},ir=Mn("node attribute"),cr="@",lr=kn("@",!1),fr=function(t){return du("Attribute").merge(t)},hr=function(t){return du("Attribute").set({id:t.get("value")})},pr=Mn("query parameter reference"),Ar="{",dr=kn("{",!1),xr="}",br=kn("}",!1),gr=function(t){return du("Param").merge(t)},vr=function(t){return t},Pr=Mn("identifier"),yr=/^[a-zA-Z_]/,mr=Nn([["a","z"],["A","Z"],"_"],!1,!1),Cr=/^[a-zA-Z0-9_\-]/,_r=Nn([["a","z"],["A","Z"],["0","9"],"_","-"],!1,!1),Sr=function(t){return du("Identifier").set({id:t})},wr=Mn("quoted string literal"),qr='"',Er=kn('"',!1),Qr=/^[^"]/,Rr=Nn(['"'],!0,!1),Tr=function(t){return du("LiteralString").set({value:t.join("")})},Fr="'",Lr=kn("'",!1),jr=/^[^']/,kr=Nn(["'"],!0,!1),Nr=Mn("escaped double-quoted-string character"),Mr="\\\\",Ir=kn("\\\\",!1),Ur=function(){return"\\"},Vr='\\"',zr=kn('\\"',!1),Dr=function(){return'"'},Or="\\b",Zr=kn("\\b",!1),Br=function(){return"\b"},Kr="\\v",$r=kn("\\v",!1),Gr=function(){return"\v"},Hr="\\f",Jr=kn("\\f",!1),Wr=function(){return"\f"},Xr="\\t",Yr=kn("\\t",!1),te=function(){return"\t"},re="\\r",ee=kn("\\r",!1),ne=function(){return"\r"},ue="\\n",se=kn("\\n",!1),oe=function(){return"\n"},ae="\\e",ie=kn("\\e",!1),ce=function(){return""},le="\\x",fe=kn("\\x",!1),he=/^[0-9a-fA-F]/,pe=Nn([["0","9"],["a","f"],["A","F"]],!1,!1),Ae=function(t){return String.fromCharCode(parseInt(t,16))},de="\\u",xe=kn("\\u",!1),be=Mn("escaped single-quoted-string character"),ge="\\'",ve=kn("\\'",!1),Pe=function(){return"'"},ye=Mn("regular expression literal"),me="`",Ce=kn("`",!1),_e="\\`",Se=kn("\\`",!1),we=/^[^`]/,qe=Nn(["`"],!0,!1),Ee=function(r){var e;try{e=new RegExp(r.replace(/\\`/g,"`"))}catch(r){!function(r,e){throw e=void 0!==e?e:Un(En,qn),function(r,e){return new t(r,null,null,e)}(r,e)}(r.message)}return du("LiteralRegExp").set({value:e})},Qe=Mn("numeric literal"),Re=/^[+\-]/,Te=Nn(["+","-"],!1,!1),Fe="0b",Le=kn("0b",!1),je=/^[01]/,ke=Nn(["0","1"],!1,!1),Ne=function(t,r){return du("LiteralNumber").set({value:parseInt(t+r,2)})},Me="0o",Ie=kn("0o",!1),Ue=/^[0-7]/,Ve=Nn([["0","7"]],!1,!1),ze=function(t,r){return du("LiteralNumber").set({value:parseInt(t+r,8)})},De="0x",Oe=kn("0x",!1),Ze=function(t,r){return du("LiteralNumber").set({value:parseInt(t+r,16)})},Be=/^[0-9]/,Ke=Nn([["0","9"]],!1,!1),$e=".",Ge=kn(".",!1),He=/^[eE]/,Je=Nn(["e","E"],!1,!1),We=function(t){return du("LiteralNumber").set({value:parseFloat(t)})},Xe=function(t){return du("LiteralNumber").set({value:parseInt(t,10)})},Ye=Mn("global value"),tn="true",rn=kn("true",!1),en=function(){return du("LiteralValue").set({value:!0})},nn="false",un=kn("false",!1),sn=function(){return du("LiteralValue").set({value:!1})},on="null",an=kn("null",!1),cn=function(){return du("LiteralValue").set({value:null})},ln="NaN",fn=kn("NaN",!1),hn=function(){return du("LiteralValue").set({value:NaN})},pn="undefined",An=kn("undefined",!1),dn=function(){return du("LiteralValue").set({value:void 0})},xn=Mn("optional blank"),bn=Mn("multi-line comment"),gn="/*",vn=kn("/*",!1),Pn="*/",yn=kn("*/",!1),mn={type:"any"},Cn=Mn("any whitespaces"),_n=/^[ \t\r\n]/,Sn=Nn([" ","\t","\r","\n"],!1,!1),wn=Mn("end of file"),qn=0,En=0,Qn=[{line:1,column:1}],Rn=0,Tn=[],Fn=0,Ln={};if("startRule"in e){if(!(e.startRule in s))throw new Error("Can't start parsing from rule \""+e.startRule+'".');o=s[e.startRule]}function jn(){return Un(En,qn)}function kn(t,r){return{type:"literal",text:t,ignoreCase:r}}function Nn(t,r,e){return{type:"class",parts:t,inverted:r,ignoreCase:e}}function Mn(t){return{type:"other",description:t}}function In(t){var e,n=Qn[t];if(n)return n;for(e=t-1;!Qn[e];)e--;for(n={line:(n=Qn[e]).line,column:n.column};e<t;)10===r.charCodeAt(e)?(n.line++,n.column=1):n.column++,e++;return Qn[t]=n,n}function Un(t,r){var e=In(t),n=In(r);return{start:{offset:t,line:e.line,column:e.column},end:{offset:r,line:n.line,column:n.column}}}function Vn(t){qn<Rn||(qn>Rn&&(Rn=qn,Tn=[]),Tn.push(t))}function zn(r,e,n){return new t(t.buildMessage(r,e),r,e,n)}function Dn(){var t,e,n=38*qn+0,s=Ln[n];return s?(qn=s.nextPos,s.result):(t=qn,fu()!==u&&(e=function(){var t,e,n,s,o,a,f,h,p=38*qn+1,A=Ln[p];if(A)return qn=A.nextPos,A.result;if(t=qn,(e=On())!==u){for(n=[],s=qn,(o=fu())!==u?(44===r.charCodeAt(qn)?(a=i,qn++):(a=u,0===Fn&&Vn(c)),a!==u&&(f=fu())!==u&&(h=On())!==u?s=o=[o,a,f,h]:(qn=s,s=u)):(qn=s,s=u);s!==u;)n.push(s),s=qn,(o=fu())!==u?(44===r.charCodeAt(qn)?(a=i,qn++):(a=u,0===Fn&&Vn(c)),a!==u&&(f=fu())!==u&&(h=On())!==u?s=o=[o,a,f,h]:(qn=s,s=u)):(qn=s,s=u);n!==u?(En=t,e=l(e,n),t=e):(qn=t,t=u)}else qn=t,t=u;return Ln[p]={nextPos:qn,result:t},t}())!==u&&fu()!==u&&function(){var t,e,n=38*qn+37,s=Ln[n];return s?(qn=s.nextPos,s.result):(Fn++,t=qn,Fn++,r.length>qn?(e=r.charAt(qn),qn++):(e=u,0===Fn&&Vn(mn)),Fn--,e===u?t=void 0:(qn=t,t=u),Fn--,t===u&&(e=u,0===Fn&&Vn(wn)),Ln[n]={nextPos:qn,result:t},t)}()!==u?(En=t,t=a(e)):(qn=t,t=u),Ln[n]={nextPos:qn,result:t},t)}function On(){var t,e,n,s,o,a,i=38*qn+2,c=Ln[i];if(c)return qn=c.nextPos,c.result;if(t=qn,(e=function(){var t,e,n,s,o,a=38*qn+3,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=Bn())===u&&(e=null),e!==u&&fu()!==u&&(n=Kn())!==u&&fu()!==u?(33===r.charCodeAt(qn)?(s=h,qn++):(s=u,0===Fn&&Vn(p)),s===u&&(s=null),s!==u&&fu()!==u?((o=$n())===u&&(o=null),o!==u?(En=t,e=A(e,n,s,o),t=e):(qn=t,t=u)):(qn=t,t=u)):(qn=t,t=u),Ln[a]={nextPos:qn,result:t},t)}())!==u){for(n=[],s=qn,(o=fu())!==u&&(a=Zn())!==u?s=o=[o,a]:(qn=s,s=u);s!==u;)n.push(s),s=qn,(o=fu())!==u&&(a=Zn())!==u?s=o=[o,a]:(qn=s,s=u);n!==u?(En=t,t=e=f(e,n)):(qn=t,t=u)}else qn=t,t=u;return Ln[i]={nextPos:qn,result:t},t}function Zn(){var t,e,n,s,o,a=38*qn+4,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=Bn())!==u&&fu()!==u&&(n=Kn())!==u&&fu()!==u?(33===r.charCodeAt(qn)?(s=h,qn++):(s=u,0===Fn&&Vn(p)),s===u&&(s=null),s!==u&&fu()!==u?((o=$n())===u&&(o=null),o!==u?(En=t,t=e=A(e,n,s,o)):(qn=t,t=u)):(qn=t,t=u)):(qn=t,t=u),Ln[a]={nextPos:qn,result:t},t)}function Bn(){var t,e,n,s=38*qn+5,o=Ln[s];return o?(qn=o.nextPos,o.result):(Fn++,t=qn,e=qn,r.substr(qn,2)===x?(n=x,qn+=2):(n=u,0===Fn&&Vn(b)),n===u&&(47===r.charCodeAt(qn)?(n=g,qn++):(n=u,0===Fn&&Vn(v)),n===u&&(r.substr(qn,3)===P?(n=P,qn+=3):(n=u,0===Fn&&Vn(y)),n===u&&(r.substr(qn,2)===m?(n=m,qn+=2):(n=u,0===Fn&&Vn(C)),n===u&&(r.substr(qn,3)===_?(n=_,qn+=3):(n=u,0===Fn&&Vn(S)),n===u&&(r.substr(qn,2)===w?(n=w,qn+=2):(n=u,0===Fn&&Vn(q)),n===u&&(r.substr(qn,3)===E?(n=E,qn+=3):(n=u,0===Fn&&Vn(Q)),n===u&&(r.substr(qn,2)===R?(n=R,qn+=2):(n=u,0===Fn&&Vn(T)),n===u&&(r.substr(qn,4)===F?(n=F,qn+=4):(n=u,0===Fn&&Vn(L)),n===u&&(r.substr(qn,3)===j?(n=j,qn+=3):(n=u,0===Fn&&Vn(k)),n===u&&(r.substr(qn,3)===N?(n=N,qn+=3):(n=u,0===Fn&&Vn(M)),n===u&&(r.substr(qn,2)===I?(n=I,qn+=2):(n=u,0===Fn&&Vn(U)),n===u&&(r.substr(qn,3)===V?(n=V,qn+=3):(n=u,0===Fn&&Vn(z)),n===u&&(r.substr(qn,3)===D?(n=D,qn+=3):(n=u,0===Fn&&Vn(O))))))))))))))),(e=n!==u?r.substring(e,qn):n)!==u?((n=function(){var t,e,n,s=38*qn+6,o=Ln[s];return o?(qn=o.nextPos,o.result):(t=qn,58===r.charCodeAt(qn)?(e=B,qn++):(e=u,0===Fn&&Vn(K)),e!==u&&(n=ou())!==u?(En=t,e=$(n),t=e):(qn=t,t=u),t===u&&(t=qn,58===r.charCodeAt(qn)?(e=B,qn++):(e=u,0===Fn&&Vn(K)),e!==u&&(n=au())!==u?(En=t,e=G(n),t=e):(qn=t,t=u)),Ln[s]={nextPos:qn,result:t},t)}())===u&&(n=null),n!==u?(En=t,t=e=Z(e,n)):(qn=t,t=u)):(qn=t,t=u),Fn--,t===u&&(e=u,0===Fn&&Vn(d)),Ln[s]={nextPos:qn,result:t},t)}function Kn(){var t,e,n=38*qn+7,s=Ln[n];return s?(qn=s.nextPos,s.result):(t=qn,(e=ou())!==u&&(En=t,e=H(e)),(t=e)===u&&(t=qn,(e=au())!==u&&(En=t,e=J(e)),(t=e)===u&&(t=qn,42===r.charCodeAt(qn)?(e=W,qn++):(e=u,0===Fn&&Vn(X)),e!==u&&(En=t,e=Y()),t=e)),Ln[n]={nextPos:qn,result:t},t)}function $n(){var t,e,n,s,o=38*qn+8,a=Ln[o];return a?(qn=a.nextPos,a.result):(t=qn,91===r.charCodeAt(qn)?(e=tt,qn++):(e=u,0===Fn&&Vn(rt)),e!==u&&fu()!==u&&(n=Gn())!==u&&fu()!==u?(93===r.charCodeAt(qn)?(s=et,qn++):(s=u,0===Fn&&Vn(nt)),s!==u?(En=t,t=e=ut(n)):(qn=t,t=u)):(qn=t,t=u),Ln[o]={nextPos:qn,result:t},t)}function Gn(){var t,e,n,s,o,a,i=38*qn+9,c=Ln[i];return c?(qn=c.nextPos,c.result):(t=qn,(e=Hn())!==u&&fu()!==u?(r.substr(qn,2)===st?(n=st,qn+=2):(n=u,0===Fn&&Vn(ot)),n!==u&&fu()!==u&&(s=Gn())!==u?(En=t,t=e=at(e,s)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=qn,(e=Hn())!==u&&fu()!==u?(63===r.charCodeAt(qn)?(n=it,qn++):(n=u,0===Fn&&Vn(ct)),n!==u&&fu()!==u&&(s=Gn())!==u&&fu()!==u?(58===r.charCodeAt(qn)?(o=B,qn++):(o=u,0===Fn&&Vn(K)),o!==u&&fu()!==u&&(a=Gn())!==u?(En=t,t=e=lt(e,s,a)):(qn=t,t=u)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=Hn())),Ln[i]={nextPos:qn,result:t},t)}function Hn(){var t,e,n,s,o,a=38*qn+10,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=Jn())!==u&&fu()!==u?(n=qn,r.substr(qn,2)===ft?(s=ft,qn+=2):(s=u,0===Fn&&Vn(ht)),(n=s!==u?r.substring(n,qn):s)!==u&&(s=fu())!==u&&(o=Hn())!==u?(En=t,t=e=pt(e,n,o)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=Jn()),Ln[a]={nextPos:qn,result:t},t)}function Jn(){var t,e,n,s,o,a=38*qn+11,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=Wn())!==u&&fu()!==u?(n=qn,r.substr(qn,2)===At?(s=At,qn+=2):(s=u,0===Fn&&Vn(dt)),(n=s!==u?r.substring(n,qn):s)!==u&&(s=fu())!==u&&(o=Jn())!==u?(En=t,t=e=pt(e,n,o)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=Wn()),Ln[a]={nextPos:qn,result:t},t)}function Wn(){var t,e,n,s,o,a=38*qn+12,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=Xn())!==u&&fu()!==u?(n=qn,124===r.charCodeAt(qn)?(s=xt,qn++):(s=u,0===Fn&&Vn(bt)),(n=s!==u?r.substring(n,qn):s)!==u&&(s=fu())!==u&&(o=Wn())!==u?(En=t,t=e=gt(e,n,o)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=Xn()),Ln[a]={nextPos:qn,result:t},t)}function Xn(){var t,e,n,s,o,a=38*qn+13,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=Yn())!==u&&fu()!==u?(n=qn,94===r.charCodeAt(qn)?(s=vt,qn++):(s=u,0===Fn&&Vn(Pt)),(n=s!==u?r.substring(n,qn):s)!==u&&(s=fu())!==u&&(o=Xn())!==u?(En=t,t=e=gt(e,n,o)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=Yn()),Ln[a]={nextPos:qn,result:t},t)}function Yn(){var t,e,n,s,o,a=38*qn+14,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=tu())!==u&&fu()!==u?(n=qn,38===r.charCodeAt(qn)?(s=yt,qn++):(s=u,0===Fn&&Vn(mt)),(n=s!==u?r.substring(n,qn):s)!==u&&(s=fu())!==u&&(o=Yn())!==u?(En=t,t=e=gt(e,n,o)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=tu()),Ln[a]={nextPos:qn,result:t},t)}function tu(){var t,e,n,s,o,a=38*qn+15,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=ru())!==u&&fu()!==u?(n=qn,r.substr(qn,2)===Ct?(s=Ct,qn+=2):(s=u,0===Fn&&Vn(_t)),s===u&&(r.substr(qn,2)===St?(s=St,qn+=2):(s=u,0===Fn&&Vn(wt)),s===u&&(r.substr(qn,2)===qt?(s=qt,qn+=2):(s=u,0===Fn&&Vn(Et)),s===u&&(r.substr(qn,2)===Qt?(s=Qt,qn+=2):(s=u,0===Fn&&Vn(Rt)),s===u&&(60===r.charCodeAt(qn)?(s=Tt,qn++):(s=u,0===Fn&&Vn(Ft)),s===u&&(62===r.charCodeAt(qn)?(s=Lt,qn++):(s=u,0===Fn&&Vn(jt)),s===u&&(r.substr(qn,2)===kt?(s=kt,qn+=2):(s=u,0===Fn&&Vn(Nt)),s===u&&(r.substr(qn,2)===Mt?(s=Mt,qn+=2):(s=u,0===Fn&&Vn(It))))))))),(n=s!==u?r.substring(n,qn):s)!==u&&(s=fu())!==u&&(o=tu())!==u?(En=t,t=e=Ut(e,n,o)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=ru()),Ln[a]={nextPos:qn,result:t},t)}function ru(){var t,e,n,s,o,a=38*qn+16,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=eu())!==u&&fu()!==u?(n=qn,r.substr(qn,2)===Vt?(s=Vt,qn+=2):(s=u,0===Fn&&Vn(zt)),s===u&&(r.substr(qn,2)===Dt?(s=Dt,qn+=2):(s=u,0===Fn&&Vn(Ot))),(n=s!==u?r.substring(n,qn):s)!==u&&(s=fu())!==u&&(o=ru())!==u?(En=t,t=e=gt(e,n,o)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=eu()),Ln[a]={nextPos:qn,result:t},t)}function eu(){var t,e,n,s,o,a=38*qn+17,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=nu())!==u&&fu()!==u?(n=qn,43===r.charCodeAt(qn)?(s=Zt,qn++):(s=u,0===Fn&&Vn(Bt)),s===u&&(45===r.charCodeAt(qn)?(s=Kt,qn++):(s=u,0===Fn&&Vn($t))),(n=s!==u?r.substring(n,qn):s)!==u&&(s=fu())!==u&&(o=eu())!==u?(En=t,t=e=Gt(e,n,o)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=nu()),Ln[a]={nextPos:qn,result:t},t)}function nu(){var t,e,n,s,o,a=38*qn+18,i=Ln[a];return i?(qn=i.nextPos,i.result):(t=qn,(e=uu())!==u&&fu()!==u?(n=qn,r.substr(qn,2)===Ht?(s=Ht,qn+=2):(s=u,0===Fn&&Vn(Jt)),s===u&&(42===r.charCodeAt(qn)?(s=W,qn++):(s=u,0===Fn&&Vn(X)),s===u&&(47===r.charCodeAt(qn)?(s=g,qn++):(s=u,0===Fn&&Vn(v)),s===u&&(37===r.charCodeAt(qn)?(s=Wt,qn++):(s=u,0===Fn&&Vn(Xt))))),(n=s!==u?r.substring(n,qn):s)!==u&&(s=fu())!==u&&(o=nu())!==u?(En=t,t=e=Gt(e,n,o)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=uu()),Ln[a]={nextPos:qn,result:t},t)}function uu(){var t,e,n,s=38*qn+19,o=Ln[s];return o?(qn=o.nextPos,o.result):(t=qn,e=qn,33===r.charCodeAt(qn)?(n=h,qn++):(n=u,0===Fn&&Vn(p)),n===u&&(126===r.charCodeAt(qn)?(n=Yt,qn++):(n=u,0===Fn&&Vn(tr))),(e=n!==u?r.substring(e,qn):n)!==u&&(n=su())!==u?(En=t,t=e=rr(e,n)):(qn=t,t=u),t===u&&(t=su()),Ln[s]={nextPos:qn,result:t},t)}function su(){var t,e=38*qn+20,n=Ln[e];return n?(qn=n.nextPos,n.result):((t=function(){var t,e,n,s,o,a=38*qn+21,l=Ln[a];return l?(qn=l.nextPos,l.result):(t=qn,(e=ou())!==u&&fu()!==u?(40===r.charCodeAt(qn)?(n=er,qn++):(n=u,0===Fn&&Vn(nr)),n!==u&&fu()!==u?((s=function(){var t,e,n,s,o,a,l,f,h=38*qn+22,p=Ln[h];if(p)return qn=p.nextPos,p.result;if(t=qn,(e=Gn())!==u){for(n=[],s=qn,(o=fu())!==u?(44===r.charCodeAt(qn)?(a=i,qn++):(a=u,0===Fn&&Vn(c)),a!==u&&(l=fu())!==u&&(f=Gn())!==u?s=o=[o,a,l,f]:(qn=s,s=u)):(qn=s,s=u);s!==u;)n.push(s),s=qn,(o=fu())!==u?(44===r.charCodeAt(qn)?(a=i,qn++):(a=u,0===Fn&&Vn(c)),a!==u&&(l=fu())!==u&&(f=Gn())!==u?s=o=[o,a,l,f]:(qn=s,s=u)):(qn=s,s=u);n!==u?(En=t,e=ar(e,n),t=e):(qn=t,t=u)}else qn=t,t=u;return Ln[h]={nextPos:qn,result:t},t}())===u&&(s=null),s!==u&&fu()!==u?(41===r.charCodeAt(qn)?(o=ur,qn++):(o=u,0===Fn&&Vn(sr)),o!==u?(En=t,e=or(e,s),t=e):(qn=t,t=u)):(qn=t,t=u)):(qn=t,t=u)):(qn=t,t=u),Ln[a]={nextPos:qn,result:t},t)}())===u&&(t=function(){var t,e,n,s=38*qn+23,o=Ln[s];return o?(qn=o.nextPos,o.result):(Fn++,t=qn,64===r.charCodeAt(qn)?(e=cr,qn++):(e=u,0===Fn&&Vn(lr)),e!==u&&(n=ou())!==u?(En=t,e=fr(n),t=e):(qn=t,t=u),t===u&&(t=qn,64===r.charCodeAt(qn)?(e=cr,qn++):(e=u,0===Fn&&Vn(lr)),e!==u&&(n=au())!==u?(En=t,e=hr(n),t=e):(qn=t,t=u)),Fn--,t===u&&(e=u,0===Fn&&Vn(ir)),Ln[s]={nextPos:qn,result:t},t)}())===u&&(t=function(){var t,e,n,s,o=38*qn+24,a=Ln[o];return a?(qn=a.nextPos,a.result):(Fn++,t=qn,123===r.charCodeAt(qn)?(e=Ar,qn++):(e=u,0===Fn&&Vn(dr)),e!==u&&fu()!==u&&(n=ou())!==u&&fu()!==u?(125===r.charCodeAt(qn)?(s=xr,qn++):(s=u,0===Fn&&Vn(br)),s!==u?(En=t,e=gr(n),t=e):(qn=t,t=u)):(qn=t,t=u),Fn--,t===u&&(e=u,0===Fn&&Vn(pr)),Ln[o]={nextPos:qn,result:t},t)}())===u&&(t=function(){var t,e=38*qn+25,n=Ln[e];return n?(qn=n.nextPos,n.result):((t=au())===u&&(t=function(){var t,e,n,s,o,a=38*qn+31,i=Ln[a];if(i)return qn=i.nextPos,i.result;if(Fn++,t=qn,96===r.charCodeAt(qn)?(e=me,qn++):(e=u,0===Fn&&Vn(Ce)),e!==u){for(n=qn,s=[],r.substr(qn,2)===_e?(o=_e,qn+=2):(o=u,0===Fn&&Vn(Se)),o===u&&(we.test(r.charAt(qn))?(o=r.charAt(qn),qn++):(o=u,0===Fn&&Vn(qe)));o!==u;)s.push(o),r.substr(qn,2)===_e?(o=_e,qn+=2):(o=u,0===Fn&&Vn(Se)),o===u&&(we.test(r.charAt(qn))?(o=r.charAt(qn),qn++):(o=u,0===Fn&&Vn(qe)));(n=s!==u?r.substring(n,qn):s)!==u?(96===r.charCodeAt(qn)?(s=me,qn++):(s=u,0===Fn&&Vn(Ce)),s!==u?(En=t,e=Ee(n),t=e):(qn=t,t=u)):(qn=t,t=u)}else qn=t,t=u;return Fn--,t===u&&(e=u,0===Fn&&Vn(ye)),Ln[a]={nextPos:qn,result:t},t}())===u&&(t=function(){var t,e,n,s,o,a,i,c,l,f,h,p,A=38*qn+32,d=Ln[A];if(d)return qn=d.nextPos,d.result;if(Fn++,t=qn,e=qn,Re.test(r.charAt(qn))?(n=r.charAt(qn),qn++):(n=u,0===Fn&&Vn(Te)),n===u&&(n=null),(e=n!==u?r.substring(e,qn):n)!==u)if(r.substr(qn,2)===Fe?(n=Fe,qn+=2):(n=u,0===Fn&&Vn(Le)),n!==u){if(s=qn,o=[],je.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(ke)),a!==u)for(;a!==u;)o.push(a),je.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(ke));else o=u;(s=o!==u?r.substring(s,qn):o)!==u?(En=t,e=Ne(e,s),t=e):(qn=t,t=u)}else qn=t,t=u;else qn=t,t=u;if(t===u){if(t=qn,e=qn,Re.test(r.charAt(qn))?(n=r.charAt(qn),qn++):(n=u,0===Fn&&Vn(Te)),n===u&&(n=null),(e=n!==u?r.substring(e,qn):n)!==u)if(r.substr(qn,2)===Me?(n=Me,qn+=2):(n=u,0===Fn&&Vn(Ie)),n!==u){if(s=qn,o=[],Ue.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(Ve)),a!==u)for(;a!==u;)o.push(a),Ue.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(Ve));else o=u;(s=o!==u?r.substring(s,qn):o)!==u?(En=t,e=ze(e,s),t=e):(qn=t,t=u)}else qn=t,t=u;else qn=t,t=u;if(t===u){if(t=qn,e=qn,Re.test(r.charAt(qn))?(n=r.charAt(qn),qn++):(n=u,0===Fn&&Vn(Te)),n===u&&(n=null),(e=n!==u?r.substring(e,qn):n)!==u)if(r.substr(qn,2)===De?(n=De,qn+=2):(n=u,0===Fn&&Vn(Oe)),n!==u){if(s=qn,o=[],he.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(pe)),a!==u)for(;a!==u;)o.push(a),he.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(pe));else o=u;(s=o!==u?r.substring(s,qn):o)!==u?(En=t,e=Ze(e,s),t=e):(qn=t,t=u)}else qn=t,t=u;else qn=t,t=u;if(t===u){if(t=qn,e=qn,n=qn,Re.test(r.charAt(qn))?(s=r.charAt(qn),qn++):(s=u,0===Fn&&Vn(Te)),s===u&&(s=null),s!==u){for(o=[],Be.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(Ke));a!==u;)o.push(a),Be.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(Ke));if(o!==u)if(46===r.charCodeAt(qn)?(a=$e,qn++):(a=u,0===Fn&&Vn(Ge)),a!==u){if(i=[],Be.test(r.charAt(qn))?(c=r.charAt(qn),qn++):(c=u,0===Fn&&Vn(Ke)),c!==u)for(;c!==u;)i.push(c),Be.test(r.charAt(qn))?(c=r.charAt(qn),qn++):(c=u,0===Fn&&Vn(Ke));else i=u;if(i!==u){if(c=qn,He.test(r.charAt(qn))?(l=r.charAt(qn),qn++):(l=u,0===Fn&&Vn(Je)),l!==u)if(Re.test(r.charAt(qn))?(f=r.charAt(qn),qn++):(f=u,0===Fn&&Vn(Te)),f===u&&(f=null),f!==u){if(h=[],Be.test(r.charAt(qn))?(p=r.charAt(qn),qn++):(p=u,0===Fn&&Vn(Ke)),p!==u)for(;p!==u;)h.push(p),Be.test(r.charAt(qn))?(p=r.charAt(qn),qn++):(p=u,0===Fn&&Vn(Ke));else h=u;h!==u?c=l=[l,f,h]:(qn=c,c=u)}else qn=c,c=u;else qn=c,c=u;c===u&&(c=null),c!==u?n=s=[s,o,a,i,c]:(qn=n,n=u)}else qn=n,n=u}else qn=n,n=u;else qn=n,n=u}else qn=n,n=u;if((e=n!==u?r.substring(e,qn):n)!==u&&(En=t,e=We(e)),(t=e)===u){if(t=qn,e=qn,n=qn,Re.test(r.charAt(qn))?(s=r.charAt(qn),qn++):(s=u,0===Fn&&Vn(Te)),s===u&&(s=null),s!==u){if(o=[],Be.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(Ke)),a!==u)for(;a!==u;)o.push(a),Be.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(Ke));else o=u;o!==u?n=s=[s,o]:(qn=n,n=u)}else qn=n,n=u;(e=n!==u?r.substring(e,qn):n)!==u&&(En=t,e=Xe(e)),t=e}}}}return Fn--,t===u&&(e=u,0===Fn&&Vn(Qe)),Ln[A]={nextPos:qn,result:t},t}())===u&&(t=lu()),Ln[e]={nextPos:qn,result:t},t)}())===u&&(t=function(){var t,e,n,s,o=38*qn+26,a=Ln[o];return a?(qn=a.nextPos,a.result):(t=qn,40===r.charCodeAt(qn)?(e=er,qn++):(e=u,0===Fn&&Vn(nr)),e!==u&&fu()!==u&&(n=Gn())!==u&&fu()!==u?(41===r.charCodeAt(qn)?(s=ur,qn++):(s=u,0===Fn&&Vn(sr)),s!==u?(En=t,e=vr(n),t=e):(qn=t,t=u)):(qn=t,t=u),Ln[o]={nextPos:qn,result:t},t)}())===u&&(t=On()),Ln[e]={nextPos:qn,result:t},t)}function ou(){var t,e,n,s,o,a,i,c=38*qn+27,l=Ln[c];if(l)return qn=l.nextPos,l.result;if(Fn++,t=qn,e=qn,n=qn,s=qn,Fn++,o=lu(),Fn--,o===u?s=void 0:(qn=s,s=u),s!==u)if(yr.test(r.charAt(qn))?(o=r.charAt(qn),qn++):(o=u,0===Fn&&Vn(mr)),o!==u){for(a=[],Cr.test(r.charAt(qn))?(i=r.charAt(qn),qn++):(i=u,0===Fn&&Vn(_r));i!==u;)a.push(i),Cr.test(r.charAt(qn))?(i=r.charAt(qn),qn++):(i=u,0===Fn&&Vn(_r));a!==u?n=s=[s,o,a]:(qn=n,n=u)}else qn=n,n=u;else qn=n,n=u;return(e=n!==u?r.substring(e,qn):n)!==u&&(En=t,e=Sr(e)),Fn--,(t=e)===u&&(e=u,0===Fn&&Vn(Pr)),Ln[c]={nextPos:qn,result:t},t}function au(){var t,e,n,s,o=38*qn+28,a=Ln[o];if(a)return qn=a.nextPos,a.result;if(Fn++,t=qn,34===r.charCodeAt(qn)?(e=qr,qn++):(e=u,0===Fn&&Vn(Er)),e!==u){for(n=[],(s=iu())===u&&(Qr.test(r.charAt(qn))?(s=r.charAt(qn),qn++):(s=u,0===Fn&&Vn(Rr)));s!==u;)n.push(s),(s=iu())===u&&(Qr.test(r.charAt(qn))?(s=r.charAt(qn),qn++):(s=u,0===Fn&&Vn(Rr)));n!==u?(34===r.charCodeAt(qn)?(s=qr,qn++):(s=u,0===Fn&&Vn(Er)),s!==u?(En=t,t=e=Tr(n)):(qn=t,t=u)):(qn=t,t=u)}else qn=t,t=u;if(t===u)if(t=qn,39===r.charCodeAt(qn)?(e=Fr,qn++):(e=u,0===Fn&&Vn(Lr)),e!==u){for(n=[],(s=cu())===u&&(jr.test(r.charAt(qn))?(s=r.charAt(qn),qn++):(s=u,0===Fn&&Vn(kr)));s!==u;)n.push(s),(s=cu())===u&&(jr.test(r.charAt(qn))?(s=r.charAt(qn),qn++):(s=u,0===Fn&&Vn(kr)));n!==u?(39===r.charCodeAt(qn)?(s=Fr,qn++):(s=u,0===Fn&&Vn(Lr)),s!==u?(En=t,t=e=Tr(n)):(qn=t,t=u)):(qn=t,t=u)}else qn=t,t=u;return Fn--,t===u&&(e=u,0===Fn&&Vn(wr)),Ln[o]={nextPos:qn,result:t},t}function iu(){var t,e,n,s,o,a,i,c,l=38*qn+29,f=Ln[l];return f?(qn=f.nextPos,f.result):(Fn++,t=qn,r.substr(qn,2)===Mr?(e=Mr,qn+=2):(e=u,0===Fn&&Vn(Ir)),e!==u&&(En=t,e=Ur()),(t=e)===u&&(t=qn,r.substr(qn,2)===Vr?(e=Vr,qn+=2):(e=u,0===Fn&&Vn(zr)),e!==u&&(En=t,e=Dr()),(t=e)===u&&(t=qn,r.substr(qn,2)===Or?(e=Or,qn+=2):(e=u,0===Fn&&Vn(Zr)),e!==u&&(En=t,e=Br()),(t=e)===u&&(t=qn,r.substr(qn,2)===Kr?(e=Kr,qn+=2):(e=u,0===Fn&&Vn($r)),e!==u&&(En=t,e=Gr()),(t=e)===u&&(t=qn,r.substr(qn,2)===Hr?(e=Hr,qn+=2):(e=u,0===Fn&&Vn(Jr)),e!==u&&(En=t,e=Wr()),(t=e)===u&&(t=qn,r.substr(qn,2)===Xr?(e=Xr,qn+=2):(e=u,0===Fn&&Vn(Yr)),e!==u&&(En=t,e=te()),(t=e)===u&&(t=qn,r.substr(qn,2)===re?(e=re,qn+=2):(e=u,0===Fn&&Vn(ee)),e!==u&&(En=t,e=ne()),(t=e)===u&&(t=qn,r.substr(qn,2)===ue?(e=ue,qn+=2):(e=u,0===Fn&&Vn(se)),e!==u&&(En=t,e=oe()),(t=e)===u&&(t=qn,r.substr(qn,2)===ae?(e=ae,qn+=2):(e=u,0===Fn&&Vn(ie)),e!==u&&(En=t,e=ce()),(t=e)===u&&(t=qn,r.substr(qn,2)===le?(e=le,qn+=2):(e=u,0===Fn&&Vn(fe)),e!==u?(n=qn,s=qn,he.test(r.charAt(qn))?(o=r.charAt(qn),qn++):(o=u,0===Fn&&Vn(pe)),o!==u?(he.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(pe)),a!==u?s=o=[o,a]:(qn=s,s=u)):(qn=s,s=u),(n=s!==u?r.substring(n,qn):s)!==u?(En=t,t=e=Ae(n)):(qn=t,t=u)):(qn=t,t=u),t===u&&(t=qn,r.substr(qn,2)===de?(e=de,qn+=2):(e=u,0===Fn&&Vn(xe)),e!==u?(n=qn,s=qn,he.test(r.charAt(qn))?(o=r.charAt(qn),qn++):(o=u,0===Fn&&Vn(pe)),o!==u?(he.test(r.charAt(qn))?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(pe)),a!==u?(he.test(r.charAt(qn))?(i=r.charAt(qn),qn++):(i=u,0===Fn&&Vn(pe)),i!==u?(he.test(r.charAt(qn))?(c=r.charAt(qn),qn++):(c=u,0===Fn&&Vn(pe)),c!==u?s=o=[o,a,i,c]:(qn=s,s=u)):(qn=s,s=u)):(qn=s,s=u)):(qn=s,s=u),(n=s!==u?r.substring(n,qn):s)!==u?(En=t,t=e=Ae(n)):(qn=t,t=u)):(qn=t,t=u))))))))))),Fn--,t===u&&(e=u,0===Fn&&Vn(Nr)),Ln[l]={nextPos:qn,result:t},t)}function cu(){var t,e,n=38*qn+30,s=Ln[n];return s?(qn=s.nextPos,s.result):(Fn++,t=qn,r.substr(qn,2)===ge?(e=ge,qn+=2):(e=u,0===Fn&&Vn(ve)),e!==u&&(En=t,e=Pe()),Fn--,(t=e)===u&&(e=u,0===Fn&&Vn(be)),Ln[n]={nextPos:qn,result:t},t)}function lu(){var t,e,n=38*qn+33,s=Ln[n];return s?(qn=s.nextPos,s.result):(Fn++,t=qn,r.substr(qn,4)===tn?(e=tn,qn+=4):(e=u,0===Fn&&Vn(rn)),e!==u&&(En=t,e=en()),(t=e)===u&&(t=qn,r.substr(qn,5)===nn?(e=nn,qn+=5):(e=u,0===Fn&&Vn(un)),e!==u&&(En=t,e=sn()),(t=e)===u&&(t=qn,r.substr(qn,4)===on?(e=on,qn+=4):(e=u,0===Fn&&Vn(an)),e!==u&&(En=t,e=cn()),(t=e)===u&&(t=qn,r.substr(qn,3)===ln?(e=ln,qn+=3):(e=u,0===Fn&&Vn(fn)),e!==u&&(En=t,e=hn()),(t=e)===u&&(t=qn,r.substr(qn,9)===pn?(e=pn,qn+=9):(e=u,0===Fn&&Vn(An)),e!==u&&(En=t,e=dn()),t=e)))),Fn--,t===u&&(e=u,0===Fn&&Vn(Ye)),Ln[n]={nextPos:qn,result:t},t)}function fu(){var t,r,e=38*qn+34,n=Ln[e];if(n)return qn=n.nextPos,n.result;for(Fn++,t=[],(r=hu())===u&&(r=pu());r!==u;)t.push(r),(r=hu())===u&&(r=pu());return Fn--,t===u&&(r=u,0===Fn&&Vn(xn)),Ln[e]={nextPos:qn,result:t},t}function hu(){var t,e,n,s,o,a,i=38*qn+35,c=Ln[i];if(c)return qn=c.nextPos,c.result;if(Fn++,t=qn,r.substr(qn,2)===gn?(e=gn,qn+=2):(e=u,0===Fn&&Vn(vn)),e!==u){for(n=[],s=qn,o=qn,Fn++,r.substr(qn,2)===Pn?(a=Pn,qn+=2):(a=u,0===Fn&&Vn(yn)),Fn--,a===u?o=void 0:(qn=o,o=u),o!==u?(r.length>qn?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(mn)),a!==u?s=o=[o,a]:(qn=s,s=u)):(qn=s,s=u);s!==u;)n.push(s),s=qn,o=qn,Fn++,r.substr(qn,2)===Pn?(a=Pn,qn+=2):(a=u,0===Fn&&Vn(yn)),Fn--,a===u?o=void 0:(qn=o,o=u),o!==u?(r.length>qn?(a=r.charAt(qn),qn++):(a=u,0===Fn&&Vn(mn)),a!==u?s=o=[o,a]:(qn=s,s=u)):(qn=s,s=u);n!==u?(r.substr(qn,2)===Pn?(s=Pn,qn+=2):(s=u,0===Fn&&Vn(yn)),s!==u?t=e=[e,n,s]:(qn=t,t=u)):(qn=t,t=u)}else qn=t,t=u;return Fn--,t===u&&(e=u,0===Fn&&Vn(bn)),Ln[i]={nextPos:qn,result:t},t}function pu(){var t,e,n=38*qn+36,s=Ln[n];if(s)return qn=s.nextPos,s.result;if(Fn++,t=[],_n.test(r.charAt(qn))?(e=r.charAt(qn),qn++):(e=u,0===Fn&&Vn(Sn)),e!==u)for(;e!==u;)t.push(e),_n.test(r.charAt(qn))?(e=r.charAt(qn),qn++):(e=u,0===Fn&&Vn(Sn));else t=u;return Fn--,t===u&&(e=u,0===Fn&&Vn(Cn)),Ln[n]={nextPos:qn,result:t},t}var Au=e.util.makeUnroll(jn,e),du=e.util.makeAST(jn,e);if((n=o())!==u&&qn===r.length)return n;throw n!==u&&qn<r.length&&Vn({type:"end"}),zn(Tn,Rn<r.length?r.charAt(Rn):null,Rn<r.length?Un(Rn,Rn+1):Un(Rn,Rn))}}}(),ASTQQuery=exports.default=function(){function t(r){_classCallCheck(this,t),this.asty=new _asty.default,this.ast=null,r&&this.compile(r)}return _createClass(t,[{key:"compile",value:function(t,r){var e=this;r&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\nASTQ: compile: | "+t);var n=_pegjsUtil.default.parse(ASTQQueryParse,t,{startRule:"query",makeAST:function(t,r,n,u){return e.asty.create.apply(e.asty,u).pos(t,r,n)}});if(null!==n.error)throw new Error("ASTQ: compile: query parsing failed:\n"+_pegjsUtil.default.errorMessage(n.error,!0).replace(/^/gm,"ERROR: "));return this.ast=n.ast,r&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\n"+this.dump().replace(/\n$/,"").replace(/^/gm,"ASTQ: compile: | ")),this}},{key:"dump",value:function(){return this.ast.dump()}},{key:"execute",value:function(t,r,e,n,u){return u&&console.log("ASTQ: execute: +-------------------------------------------------------------------------------------------------------"),new _astqQueryExec.default(r,e,n,u).execQuery(this.ast,t)}}]),t}();
},{"./astq-query-exec.js":15,"asty":1,"pegjs-util":3}],18:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!==_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQUtil=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"pad",value:function(e,t){var r=t<0?-t:t;if(e.length>r)e=e.substr(0,r);else{var o=Array(r+1-e.length).join(" ");e=t<0?e+o:o+e}return e}},{key:"truthy",value:function(e){var t;switch(_typeof(e)){case"boolean":t=e;break;case"number":t=0!==e&&!isNaN(e);break;case"string":t=""!==e;break;case"object":t=!1,null!==e&&(t=!0,e instanceof Array&&(t=e.length>0));break;default:t=!1}return t}},{key:"coerce",value:function(e,t){if(_typeof(e)!==t)try{switch(t){case"boolean":"object"===_typeof(e)&&e instanceof Array?e=0!==e.length:"boolean"!=typeof e&&(e=Boolean(e));break;case"number":"object"===_typeof(e)&&e instanceof Array?e=e.length:"number"!=typeof e&&(e=Number(e));break;case"string":"string"!=typeof e&&(e=String(e));break;case"regexp":"object"===_typeof(e)&&e instanceof RegExp||(e=new RegExp(e))}}catch(e){throw new Error("cannot coerce value into type "+t)}return e}}]),e}();
},{}],19:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var version={major:2,minor:7,micro:10,date:20230827},_default=exports.default=version;
},{}],20:[function(_dereq_,module,exports){
"use strict";var _cacheLru=_interopRequireDefault(_dereq_("cache-lru")),_astqAdapter=_interopRequireDefault(_dereq_("./astq-adapter.js")),_astqAdapterXmldom=_interopRequireDefault(_dereq_("./astq-adapter-xmldom.js")),_astqAdapterParse=_interopRequireDefault(_dereq_("./astq-adapter-parse5.js")),_astqAdapterMozast=_interopRequireDefault(_dereq_("./astq-adapter-mozast.js")),_astqAdapterGraphql=_interopRequireDefault(_dereq_("./astq-adapter-graphql.js")),_astqAdapterJson=_interopRequireDefault(_dereq_("./astq-adapter-json.js")),_astqAdapterCheerio=_interopRequireDefault(_dereq_("./astq-adapter-cheerio.js")),_astqAdapterUnist=_interopRequireDefault(_dereq_("./astq-adapter-unist.js")),_astqAdapterAsty=_interopRequireDefault(_dereq_("./astq-adapter-asty.js")),_astqFuncs=_interopRequireDefault(_dereq_("./astq-funcs.js")),_astqFuncsStd=_interopRequireDefault(_dereq_("./astq-funcs-std.js")),_astqQuery=_interopRequireDefault(_dereq_("./astq-query.js")),_astqVersion=_interopRequireDefault(_dereq_("./astq-version.js"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,_toPropertyKey(a.key),a)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"===_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!==_typeof(e)||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var a=r.call(e,t||"default");if("object"!==_typeof(a))return a;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}var ASTQ=function(){function e(){for(var t in _classCallCheck(this,e),this._adapter=(new _astqAdapter.default).register(_astqAdapterXmldom.default,!1).register(_astqAdapterParse.default,!1).register(_astqAdapterMozast.default,!1).register(_astqAdapterGraphql.default,!1).register(_astqAdapterJson.default,!1).register(_astqAdapterCheerio.default,!1).register(_astqAdapterUnist.default,!1).register(_astqAdapterAsty.default,!1),this._funcs=new _astqFuncs.default,_astqFuncsStd.default)this.func(t,_astqFuncsStd.default[t]);this._cache=new _cacheLru.default}return _createClass(e,[{key:"version",value:function(){return _astqVersion.default}},{key:"adapter",value:function(e){var t=this,r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(arguments.length<1||arguments.length>2)throw new Error("ASTQ#adapter: invalid number of arguments");if(this._adapter.unregister(),"object"===_typeof(e)&&e instanceof Array||(e=[e]),e.length>1&&r)throw new Error("ASTQ#adapter: you can force just a single adapter to not taste the AST node");return e.forEach(function(e){if("string"==typeof e)if("mozast"===e)e=_astqAdapterMozast.default;else if("graphql"===e)e=_astqAdapterGraphql.default;else if("xmldom"===e)e=_astqAdapterXmldom.default;else if("parse5"===e)e=_astqAdapterParse.default;else if("json"===e)e=_astqAdapterJson.default;else if("cheerio"===e)e=_astqAdapterCheerio.default;else if("unist"===e)e=_astqAdapterUnist.default;else{if("asty"!==e)throw new Error("ASTQ#adapter: unknown built-in adapter");e=_astqAdapterAsty.default}t._adapter.register(e,r)}),this}},{key:"func",value:function(e,t){if(2!==arguments.length)throw new Error("ASTQ#func: invalid number of arguments");return this._funcs.register(e,t),this}},{key:"cache",value:function(e){if(1!==arguments.length)throw new Error("ASTQ#cache: invalid number of arguments");return this._cache.limit(e),this}},{key:"compile",value:function(e,t){if(arguments.length<1)throw new Error("ASTQ#compile: too less arguments");if(arguments.length>2)throw new Error("ASTQ#compile: too many arguments");void 0===t&&(t=!1);var r=this._cache.get(e);return void 0===r&&((r=new _astqQuery.default).compile(e,t),this._cache.set(e,r)),r}},{key:"execute",value:function(e,t,r,a){if(arguments.length<2)throw new Error("ASTQ#execute: too less arguments");if(arguments.length>4)throw new Error("ASTQ#execute: too many arguments");void 0===r&&(r={}),void 0===a&&(a=!1);var i=this._adapter.select(e);if(void 0===i)throw new Error("ASTQ#execute: no suitable adapter found for node");return t.execute(e,i,r,this._funcs,a)}},{key:"query",value:function(e,t,r,a){if(arguments.length<2)throw new Error("ASTQ#query: too less arguments");if(arguments.length>4)throw new Error("ASTQ#query: too many arguments");return void 0===r&&(r={}),void 0===a&&(a=!1),this.execute(e,this.compile(t,a),r,a)}}]),e}();module.exports=ASTQ;
},{"./astq-adapter-asty.js":4,"./astq-adapter-cheerio.js":5,"./astq-adapter-graphql.js":6,"./astq-adapter-json.js":7,"./astq-adapter-mozast.js":8,"./astq-adapter-parse5.js":9,"./astq-adapter-unist.js":10,"./astq-adapter-xmldom.js":11,"./astq-adapter.js":12,"./astq-funcs-std.js":13,"./astq-funcs.js":14,"./astq-query.js":17,"./astq-version.js":19,"cache-lru":2}]},{},[4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20])(20)
});
